#ifndef ___CBuscaIA_h
#define ___CBuscaIA_h

#define NUMNODES        50   /*  Total de ns                      */
#define MAX             50   /*  Mximo de expanses e transies  */
#define MAXLISTS        50   /*  Mximo de listas de trajetrias   */

class CBuscaIA
{
public:

	enum TIPO{
		LARGURA,
		PROFUNDIDADE,
		ENCOSTA,
		MENOR_CUSTO
	};

	CBuscaIA(TIPO nTipo);	

private:
	
	int m_nTipo;

	/*********************
	  Smbolos globais:
	**********************/

	struct dataarea {                  // Informaes sobre um arco
		char origem[20+1];
		char destino[20+1];
		int ativo;
		int medida;
		} ;

	struct dataarea transicao[MAX];    // Array de transies = arcos

	struct dataarea expansoes[MAX];    // Array de expanses = arcos

	struct nodetype {                  // N:
		struct dataarea info;      // Informaes sobre arco
		int next;                  // Prximo n
		};

	struct nodetype node[NUMNODES];    // Caixa de ns
									   // = listas encadeadas de
									   // trajetrias

	struct list {                      // Ponteiros p/ listas em node[]
		int front;                 // Incio da trajetria
		int rear;                  // Final da trajetria
		int lenght;                // Comprimento da trajetria
		};

	/* struct list trajetorias[MAXLISTS];  estrutura do programa original
										   - nao usada */

	struct list lista[MAXLISTS];       // Ponteiros p/ listas em node[]
									   // (trajetrias)

	struct nodetype_f {                // N da fila:
		struct list list_header;   // Lista de trajetrias
		int next;                  // Prximo n
		};

	struct nodetype_f node_f[NUMNODES];// Caixa de ns node_f
									   // = fila de trajetrias

	struct fila {                      // Ponteiros para incio
			int frente;                // e fim da fila em node_f
			int tras;
		};

	struct fila f;                     // f= fila

	char origem[20], destino[20];      // Strings para receber
									   // informao teclada

	FILE *pf;                          // Arquivo de arcos

	int overflow,                      // Indicadoe de overflow
		underflow,                     // Indicador de underflow
		avail,                         // Ponteiro para prximo n
									   // disponvel em node[]

		avail_f,                       // Ponteiro para prximo n
									   // disponvel em node_f[]

		n_listas,                      // Nmero de listas

		n_expansoes;                   // Nmero de arcos partindo de
									   // no_corrente
									   // (elementos de expansoes[])

	char *no_corrente;                 // N corrente

	int n_trajetorias,                 // Total de arcos possveis
		trajet;                        // ndice do array de transies

	int meta_alcancada;                // Flag que indica
									   // se a meta foi alcanada

private:

	/**************** Funes que manipulam a fila *********************/
	int empty_f(struct fila *);
	void push_f(struct fila *,struct list *, int *);
	void push_f2(struct fila *ps,struct list *pa,int *poverflow); //** profundidade
	void create_avail_f(void);
	int getnode_f(void);
	void freenode_f(int);

	/********* Funes que manipulam as listas de trajetrias **********/

	void imprimir_lista_ei(struct list *);
	void imprimir_dado(struct dataarea *);
	void create_avail_ei(void);
	int getnode_ei(void);
	void push_lei(struct list *,struct dataarea *,int *);
	void place_ei(struct list *, struct dataarea *, int *);
	void insafter_ei(struct list *,int, struct dataarea *, int *);

	/****************** Outras funes usadas na busca *****************/

	int expandir_noLargProf(char *, struct dataarea[]);
	int expandir_noEncosta(char *, struct dataarea[]);
	int expandir_noMenorCusto(char *, struct dataarea[]);
	void criar_novas_trajetorias(struct list *,struct dataarea[], struct list[]);
	int atinge_a_meta(struct list *, char *);
	void anexar(struct list[]);
	void obter_trajetoria_corrente(struct fila *,struct list *, int *);
	int copia_no(int, int *, int *, int *);	

public:

	BOOL executar(CString strArqEntrada);

	void largura(CString strArq, struct dataarea currarea, struct list trajetoria_corrente, int  k);
	void profundidade(CString strArq, struct dataarea currarea, struct list trajetoria_corrente, int  k);
	void subidaEncosta(CString strArq, struct dataarea currarea, struct list trajetoria_corrente, int  k);
	void menorCusto(CString strArq, struct dataarea currarea, struct list trajetoria_corrente, int  k);
};

#endif // ___CBuscaIA_h